import { EventEmitter, SimpleChange, OnInit, OnDestroy } from "@angular/core";
import { EntityCollectionServiceBase } from "@ngrx/data";
import { Observable } from "rxjs";
import { MessageService, FormType, Item } from "../../../shared";
import { BaseComponent } from "../../../base/component/ngrx-data/base.component";
import { BaseDefaultDataService } from "../../shared/base-default-data-service";
/**
 * Componente basesublist de listado de entidades.
 */
export declare abstract class BaseSubListComponent<T> extends BaseComponent implements OnInit, OnDestroy {
    protected messageService: MessageService;
    protected entityService: EntityCollectionServiceBase<T>;
    protected dataService: BaseDefaultDataService<T>;
    displayInnerForm: boolean;
    modeInnerForm: FormType;
    itemSelected$: Observable<T>;
    selectedItems: number[];
    items$: Observable<T[]>;
    toolbar$: Observable<{}>;
    parent: Item;
    parentField: string;
    initLoad: boolean;
    itemsPreloaded: Item[];
    femenino: boolean;
    forceReload: EventEmitter<any>;
    reloadFromServer: boolean;
    onChange: EventEmitter<boolean>;
    constructor(messageService: MessageService, entityService: EntityCollectionServiceBase<T>, dataService: BaseDefaultDataService<T>);
    ngOnInit(): void;
    ngOnDestroy(): void;
    /** Controlamos si la propiedad initLoad cambia a true para cargar la lista de documentos */
    ngOnChanges(changes: {
        [propKey: string]: SimpleChange;
    }): void;
    createToolbar(enableDelete: boolean): Observable<{}>;
    /** Recupera el listado de elementos a mostrar en esta sublista */
    abstract getEntities(): Observable<T[]>;
    /** Abre el formulario para editar el elemento seleccionado */
    abstract gotoForm(): any;
    /** Carga los elementos a mostrar en el listado desde el servidor */
    abstract loadItems(): any;
    onToolbarButtonPressed(button: string): void;
    /** Cualquier otra accion que no sea la típica de guardar o eliminar */
    otherAction(action: string): void;
    /** Elimina un elemento de la lista cuando venimos del formulario emergente */
    deleteItem(id: number): void;
    /** Inserta o actualiza el documento */
    saveItem(item: T): void;
    /** nos piden cerrar el formulario */
    closeForm(event: any): void;
    /** Solicita confirmación para eliminar los elementos seleccionados */
    confirmDeleteItems(): void;
    /** Elimina los documentos seleccionados en el listado al pulsar el botón de elimina de la toolbar */
    deleteItems(): void;
    /** Función para hacer algo después de haber eliminado los elementos seleccionados */
    postDelete(result: boolean): void;
    /** Nos checkean algún item del listado */
    itemsChecked(selectedItems: number[]): void;
}
